require "micropub/response"
require "active_support"
require "active_support/core_ext/string/inflections"

module Micropub
  class Client
    attr_reader :post_type, :token
    def initialize(post_type, attrs={})
      @post_type = post_type
      @token     = attrs[:token]
    end

    def post(content)
      request HTTPClient.post(uri, content, headers)
    end

    def request(response)
      Micropub::Response.new(response)
    end

    def headers
      {"Authorization" => "Bearer #{token}"}
    end

    def publisher
      post_type.pluralize
    end

    def uri
      "#{host}/#{publisher}"
    end

    def host
      # ENV is temp to hardcode the host before
      # the hs router is hooked up.
      ENV["PUBLISHER_HOST"] || Micropub.configuration.me
    end
  end
end
